#!/usr/local/bin/perl

# This CGI is used for administration of IMAP accounts
# (C) 1999 Vladimir Ivaschenko <vi@maks.net>

use CGI qw/:all/;
use CGI::Carp qw(fatalsToBrowser);
use IMAP::Admin;
use Digest::MD5 qw(md5_base64);
use DBI;

$SERVER="localhost";
$D_DSN="dbi:PUT_DSN_HERE";
$D_LOGIN="PUT_LOGIN_HERE";
$D_PASSWORD="PUT_PASSWORD_HERE";

sub add_user {
if (param('addfunction') && (param('password_user') ne param('password_check')))
    { print "<b>Passwords do not match.</b>"; param('addfunction', ''); }
if (param('addfunction')) {
	print "<i>Adding user...</i><br>";
	$mailbox = param('emailaddr');
	$mailbox =~ s/\./:/g;
	$mailbox =~ s/@/::/g;
	$imapbox = "user.$mailbox";
	$password = md5_base64(param('password_user'));
	$err = $imap->create($imapbox);
	if ($err != 0) {
    	    print "<b>Error occurred building $imapbox: $imap->{'Error'}</b><br>";
	    goto ENDADD;
	}
	print "<b>Mailbox $imapbox created.</b><br>";
	$err = $imap->set_acl($imapbox, 'admin', 'lrswipcda');
	if ($err != 0) 
	{
	    print "<b>Error setting admin acl on $imapbox: $imap->{'Error'}</b><br>";
	    goto ENDADD;
	}
        if (!($dbh = DBI->connect ($D_DSN, $D_LOGIN, $D_PASSWORD)))
	{ 
	    print "<b>Could not connect to $D_DSN database server - $DBI::errstr!</b>";
	    goto ENDADD;
	}
	$rc=$dbh->do(qq{INSERT into emailtab VALUES ("$mailbox", "$password")});
	if (!($rc))
	{ 
	    print "<b>Error inserting row into emailtab - ".$dbh->errstr."</b>"; 
	}
	$dbh->disconnect;
	ENDADD:
}
param('emailaddr',(split("@",param('emailaddr')))[1]) && param('emailaddr','@'.param('emailaddr'));
param('password_user','');
param('password_check','');
print start_form,
      "Full E-Mail address (user\@domain):", textfield('emailaddr',''),
      br,
      "Password:", password_field('password_user',''),
      br,
      "Password again:", password_field('password_check',''),
      br,
      submit(-value=>"Create user",-name=>"addfunction"),
      hidden('function',"Add user"),
      hidden('username',param('username')),
      hidden('password',param('password')),
      hidden('searchmask',param('searchmask')),
      end_form;
}

sub delete_user {
if (param('delfunction'))
{
	print "<i>Deleting user...</i><br>";
	$mailbox = param('emailaddr');
	$mailbox =~ s/\./:/g;
	$mailbox =~ s/@/::/g;
	$imapbox = "user.$mailbox";
	$err = $imap->delete($imapbox);
	if ($err != 0) {
    	    print "<b>Error occurred deleting $imapbox: $imap->{'Error'}</b><br>";
	    goto ENDDEL;
	}
        if (!($dbh = DBI->connect ($D_DSN, $D_LOGIN, $D_PASSWORD)))
	{ 
	    print "<b>Could not connect to $D_DSN database server - $DBI::errstr!</b>";
	    goto ENDDEL;
	}
	$rc=$dbh->do(qq{DELETE from emailtab WHERE login="$mailbox"});
	if (!($rc))
	{
	    print "<b>Error deleting row from emailtab - ".$dbh->errstr."</b>"; 
	}
	else
	{
	    print "<b>Done!</b><br>";
	}
	$dbh->disconnect;
	ENDDEL:
}
param('emailaddr',(split("@",param('emailaddr')))[1]) && param('emailaddr','@'.param('emailaddr'));
print start_form,
      "Full E-Mail address (user\@domain) of user to <b>DELETE</b>:", textfield('emailaddr',''),
      br,
      submit(-value=>"Delete user",-name=>"delfunction"),
      hidden('function',"Delete user"),
      hidden('username',param('username')),
      hidden('password',param('password')),
      hidden('searchmask',param('searchmask')),
      end_form;
}

sub edit_user {
if (param('editfunction') eq "Set New Password" && (param('password_user') ne param('password_check')))
{
    print "<b>Passwords do not match.</b><br>";
}
elsif (param('editfunction') eq "Set New Password") 
{
    $mailbox = param('emailaddr');
    $mailbox =~ s/\./:/g;
    $mailbox =~ s/@/::/g;
    print "<i>Changing password of $mailbox mailbox..</i><br>";
    if (!($dbh = DBI->connect ($D_DSN, $D_LOGIN, $D_PASSWORD)))
    { 
        print "<b>Could not connect to $D_DSN database server - $DBI::errstr!</b>";
	goto ENDCHPASS;
    }
    $password=md5_base64(param('password_user'));
    $rc=$dbh->do(qq{UPDATE emailtab SET password="$password" WHERE login="$mailbox"});
    if (!($rc))
    {
        print "<b>Error changing row from emailtab - ".$dbh->errstr."</b>"; 
    }
    else
    {
	print "<b>Done!</b>";
    }
    $dbh->disconnect;
    ENDCHPASS:
}    
if (param('editfunction') eq "Change password") {
    print "<b>You are going to change password of ".param('emailaddr')."</b><br>";
    print start_form,
      "New Password:", password_field('password_user',''),
      br,
      "New Password again:", password_field('password_check',''),
      br,
      submit(-value=>"Set New Password",-name=>"editfunction"),
      hidden('function',"Edit user"),
      hidden('emailaddr',param('emailaddr')),
      hidden('username',param('username')),
      hidden('password',param('password')),
      hidden('searchmask',param('searchmask')),
      end_form;
      print hr;
}     
print start_form,
      "Full E-Mail address (user\@domain) of user:", textfield('emailaddr',''),
      br,
      submit(-value=>"Change password",-name=>"editfunction"),
      hidden('function',"Edit user"),
      hidden('username',param('username')),
      hidden('password',param('password')),
      hidden('searchmask',param('searchmask')),
      end_form;
}

print header;
print start_html(-title=>"IMAP administration",-bgcolor=>"F0FFF0",-background=>"graphics/background.gif");
print "<CENTER><h2>E-Mail Administration System. (C) 1999 JF Services.</h2>";
print "Please authenticate.",br
      start_form(-method=>"POST"),
      "Username: ", textfield('username',''),
      br,
      "Password: ", password_field('password',''),
      br,
      submit('Login'),
      "</CENTER>",
      end_form;

if (param('username') eq '') { print end_html; exit; }

$imap = IMAP::Admin->new('Server' => $SERVER, 'Login' => param('username'),
			 'Password' => param('password'));

print "Available functions:",br,
      start_form,
      "Mask:", textfield('searchmask','!')," ",submit(-value=>"Search",-name=>"search"),
      br,
      submit(-value=>"Add user",-name=>"function"),
      submit(-value=>"Delete user",-name=>"function"),
      submit(-value=>"Edit user",-name=>"function"),
      hidden('username',param('username')),
      hidden('password',param('password')),
      end_form;

@list = $imap->list("user.".param('searchmask'));
if (@list) {
    print "<hr><u>Search results:</u><br>";
    foreach (@list) { $_ =~ s/user\.//g; $_ =~ s/::/@/g; $_ =~ s/:/\./g; print "$_<br>"; }
    print "<hr>";
}
elsif (param('search'))
    {
    print "<b>No matching records found.</b>";
    }

if (param('function') eq "Add user") { add_user; }
if (param('function') eq "Delete user") { delete_user; }
if (param('function') eq "Edit user") { edit_user; }

print end_html;
